/* $Id$

This file is part of gldbg
Copyright © 2009  Mikko Rasa, Mikkosoft Productions
Distributed under the GPL
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include "glprint.h"

int main(int argc, char **argv)
{
	int fd;
	struct stat st;
	GlDecoder *dec;
	char *addr;
	char *end;
	char *ptr;

	if(argc<2)
	{
		fprintf(stderr, "Usage: %s <dumpfile>\n", argv[0]);
		return 1;
	}

	fd = open(argv[1], O_RDONLY);
	if(fd==-1)
	{
		perror("open");
		return 1;
	}
	fstat(fd, &st);
	addr = (char *)mmap(NULL, st.st_size, PROT_READ, MAP_SHARED, fd, 0);
	end = addr+st.st_size;
	ptr = addr;

	dec = glprint_new(NULL, 0);

	while(ptr<end)
	{
		int ret;
		ret = gldecoder_decode(dec, ptr, end-ptr);
		if(ret<0)
		{
			fprintf(stderr, "Decode error\n");
			break;
		}
		ptr += ret;
		printf("%s\n", glprint_get_buffer(dec));
	}
	munmap(addr, st.st_size);
	close(fd);
	gldecoder_delete(dec);

	return 0;
}
